{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TAttPad.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TAttPad.RawType
import HROOT.Core.TAttPad.FFI
import HROOT.Core.TAttPad.Interface
import HROOT.Core.TAttPad.Cast
import HROOT.Core.TAttPad.RawType
import HROOT.Core.TAttPad.Cast
import HROOT.Core.TAttPad.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITAttPad (TAttPad) where
        resetAttPad = xform1 c_tattpad_resetattpad
        setBottomMargin = xform1 c_tattpad_setbottommargin
        setLeftMargin = xform1 c_tattpad_setleftmargin
        setRightMargin = xform1 c_tattpad_setrightmargin
        setTopMargin = xform1 c_tattpad_settopmargin
        setMargin = xform4 c_tattpad_setmargin
        setAfile = xform1 c_tattpad_setafile
        setXfile = xform1 c_tattpad_setxfile
        setYfile = xform1 c_tattpad_setyfile
        setAstat = xform1 c_tattpad_setastat
        setXstat = xform1 c_tattpad_setxstat
        setYstat = xform1 c_tattpad_setystat

instance () => IDeletable (TAttPad) where
        delete = xform0 c_tattpad_delete

newTAttPad :: () => IO TAttPad
newTAttPad = xformnull c_tattpad_newtattpad

tAttPad_GetBottomMargin :: () => TAttPad -> IO CFloat
tAttPad_GetBottomMargin = xform0 c_tattpad_tattpad_getbottommargin

tAttPad_GetLeftMargin :: () => TAttPad -> IO CFloat
tAttPad_GetLeftMargin = xform0 c_tattpad_tattpad_getleftmargin

tAttPad_GetRightMargin :: () => TAttPad -> IO CFloat
tAttPad_GetRightMargin = xform0 c_tattpad_tattpad_getrightmargin

tAttPad_GetTopMargin :: () => TAttPad -> IO CFloat
tAttPad_GetTopMargin = xform0 c_tattpad_tattpad_gettopmargin

tAttPad_GetAfile :: () => TAttPad -> IO CFloat
tAttPad_GetAfile = xform0 c_tattpad_tattpad_getafile

tAttPad_GetXfile :: () => TAttPad -> IO CFloat
tAttPad_GetXfile = xform0 c_tattpad_tattpad_getxfile

tAttPad_GetYfile :: () => TAttPad -> IO CFloat
tAttPad_GetYfile = xform0 c_tattpad_tattpad_getyfile

tAttPad_GetAstat :: () => TAttPad -> IO CFloat
tAttPad_GetAstat = xform0 c_tattpad_tattpad_getastat

tAttPad_GetXstat :: () => TAttPad -> IO CFloat
tAttPad_GetXstat = xform0 c_tattpad_tattpad_getxstat

tAttPad_GetYstat :: () => TAttPad -> IO CFloat
tAttPad_GetYstat = xform0 c_tattpad_tattpad_getystat

tAttPad_GetFrameFillColor :: () => TAttPad -> IO CShort
tAttPad_GetFrameFillColor
  = xform0 c_tattpad_tattpad_getframefillcolor

tAttPad_GetFrameLineColor :: () => TAttPad -> IO CShort
tAttPad_GetFrameLineColor
  = xform0 c_tattpad_tattpad_getframelinecolor

tAttPad_GetFrameFillStyle :: () => TAttPad -> IO CShort
tAttPad_GetFrameFillStyle
  = xform0 c_tattpad_tattpad_getframefillstyle

tAttPad_GetFrameLineStyle :: () => TAttPad -> IO CShort
tAttPad_GetFrameLineStyle
  = xform0 c_tattpad_tattpad_getframelinestyle

tAttPad_GetFrameLineWidth :: () => TAttPad -> IO CShort
tAttPad_GetFrameLineWidth
  = xform0 c_tattpad_tattpad_getframelinewidth

tAttPad_GetFrameBorderSize :: () => TAttPad -> IO CShort
tAttPad_GetFrameBorderSize
  = xform0 c_tattpad_tattpad_getframebordersize

tAttPad_GetFrameBorderMode :: () => TAttPad -> IO CShort
tAttPad_GetFrameBorderMode
  = xform0 c_tattpad_tattpad_getframebordermode

tAttPad_SetFrameFillColor :: () => TAttPad -> CShort -> IO ()
tAttPad_SetFrameFillColor
  = xform1 c_tattpad_tattpad_setframefillcolor

tAttPad_SetFrameLineColor :: () => TAttPad -> CShort -> IO ()
tAttPad_SetFrameLineColor
  = xform1 c_tattpad_tattpad_setframelinecolor

tAttPad_SetFrameFillStyle :: () => TAttPad -> CShort -> IO ()
tAttPad_SetFrameFillStyle
  = xform1 c_tattpad_tattpad_setframefillstyle

tAttPad_SetFrameLineStyle :: () => TAttPad -> CShort -> IO ()
tAttPad_SetFrameLineStyle
  = xform1 c_tattpad_tattpad_setframelinestyle

tAttPad_SetFrameLineWidth :: () => TAttPad -> CShort -> IO ()
tAttPad_SetFrameLineWidth
  = xform1 c_tattpad_tattpad_setframelinewidth

tAttPad_SetFrameBorderSize :: () => TAttPad -> CShort -> IO ()
tAttPad_SetFrameBorderSize
  = xform1 c_tattpad_tattpad_setframebordersize

tAttPad_SetFrameBorderMode :: () => TAttPad -> CInt -> IO ()
tAttPad_SetFrameBorderMode
  = xform1 c_tattpad_tattpad_setframebordermode
