{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TDirectory.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType
import HROOT.Core.TKey.RawType

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_SetName" c_tdirectory_setname ::
               Ptr RawTDirectory -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_SetNameTitle"
               c_tdirectory_setnametitle ::
               Ptr RawTDirectory -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_SetTitle" c_tdirectory_settitle
               :: Ptr RawTDirectory -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_Clear" c_tdirectory_clear ::
               Ptr RawTDirectory -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_Draw" c_tdirectory_draw ::
               Ptr RawTDirectory -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_FindObject"
               c_tdirectory_findobject ::
               Ptr RawTDirectory -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_GetName" c_tdirectory_getname ::
               Ptr RawTDirectory -> IO CString

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_IsA" c_tdirectory_isa ::
               Ptr RawTDirectory -> IO (Ptr RawTClass)

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_Paint" c_tdirectory_paint ::
               Ptr RawTDirectory -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_printObj" c_tdirectory_printobj
               :: Ptr RawTDirectory -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_SaveAs" c_tdirectory_saveas ::
               Ptr RawTDirectory -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_Write" c_tdirectory_write ::
               Ptr RawTDirectory -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_Write_" c_tdirectory_write_ ::
               Ptr RawTDirectory -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_delete" c_tdirectory_delete ::
               Ptr RawTDirectory -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_tDirectory_AddDirectory"
               c_tdirectory_tdirectory_adddirectory :: CBool -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_tDirectory_AddDirectoryStatus"
               c_tdirectory_tdirectory_adddirectorystatus :: IO CBool

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_Append" c_tdirectory_append ::
               Ptr RawTDirectory -> Ptr RawTObject -> CBool -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_addD" c_tdirectory_addd ::
               Ptr RawTDirectory -> Ptr RawTObject -> CBool -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_AppendKey" c_tdirectory_appendkey
               :: Ptr RawTDirectory -> Ptr RawTKey -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_Close" c_tdirectory_close ::
               Ptr RawTDirectory -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_Get" c_tdirectory_get ::
               Ptr RawTDirectory -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible
               "HROOTCoreTDirectory.h TDirectory_cd_TDirectory"
               c_tdirectory_cd_tdirectory ::
               Ptr RawTDirectory -> CString -> IO CBool
