{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TDirectory.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.FFI
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TKey.RawType
import HROOT.Core.TKey.Cast
import HROOT.Core.TKey.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITDirectory (TDirectory) where
        append = xform2 c_tdirectory_append
        addD = xform2 c_tdirectory_addd
        appendKey = xform1 c_tdirectory_appendkey
        close = xform1 c_tdirectory_close
        get = xform1 c_tdirectory_get
        cd_TDirectory = xform1 c_tdirectory_cd_tdirectory

instance () => ITNamed (TDirectory) where
        setName = xform1 c_tdirectory_setname
        setNameTitle = xform2 c_tdirectory_setnametitle
        setTitle = xform1 c_tdirectory_settitle

instance () => ITObject (TDirectory) where
        clear = xform1 c_tdirectory_clear
        draw = xform1 c_tdirectory_draw
        findObject = xform1 c_tdirectory_findobject
        getName = xform0 c_tdirectory_getname
        isA = xform0 c_tdirectory_isa
        paint = xform1 c_tdirectory_paint
        printObj = xform1 c_tdirectory_printobj
        saveAs = xform2 c_tdirectory_saveas
        write = xform3 c_tdirectory_write
        write_ = xform0 c_tdirectory_write_

instance () => IDeletable (TDirectory) where
        delete = xform0 c_tdirectory_delete

tDirectory_AddDirectory :: () => CBool -> IO ()
tDirectory_AddDirectory
  = xform0 c_tdirectory_tdirectory_adddirectory

tDirectory_AddDirectoryStatus :: () => IO CBool
tDirectory_AddDirectoryStatus
  = xformnull c_tdirectory_tdirectory_adddirectorystatus
