{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TStyle.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TStyle.RawType
import HROOT.Core.TStyle.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetName" c_tstyle_setname ::
               Ptr RawTStyle -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetNameTitle" c_tstyle_setnametitle ::
               Ptr RawTStyle -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetTitle" c_tstyle_settitle ::
               Ptr RawTStyle -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetLineColor" c_tstyle_getlinecolor ::
               Ptr RawTStyle -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetLineStyle" c_tstyle_getlinestyle ::
               Ptr RawTStyle -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetLineWidth" c_tstyle_getlinewidth ::
               Ptr RawTStyle -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_ResetAttLine" c_tstyle_resetattline ::
               Ptr RawTStyle -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetLineAttributes"
               c_tstyle_setlineattributes :: Ptr RawTStyle -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetLineColor" c_tstyle_setlinecolor ::
               Ptr RawTStyle -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetLineStyle" c_tstyle_setlinestyle ::
               Ptr RawTStyle -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetLineWidth" c_tstyle_setlinewidth ::
               Ptr RawTStyle -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetFillColor" c_tstyle_setfillcolor ::
               Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetFillStyle" c_tstyle_setfillstyle ::
               Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetMarkerColor" c_tstyle_getmarkercolor
               :: Ptr RawTStyle -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetMarkerStyle" c_tstyle_getmarkerstyle
               :: Ptr RawTStyle -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetMarkerSize" c_tstyle_getmarkersize ::
               Ptr RawTStyle -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_ResetAttMarker" c_tstyle_resetattmarker
               :: Ptr RawTStyle -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetMarkerAttributes"
               c_tstyle_setmarkerattributes :: Ptr RawTStyle -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetMarkerColor" c_tstyle_setmarkercolor
               :: Ptr RawTStyle -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetMarkerStyle" c_tstyle_setmarkerstyle
               :: Ptr RawTStyle -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetMarkerSize" c_tstyle_setmarkersize ::
               Ptr RawTStyle -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetTextAlign" c_tstyle_gettextalign ::
               Ptr RawTStyle -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetTextAngle" c_tstyle_gettextangle ::
               Ptr RawTStyle -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetTextColor" c_tstyle_gettextcolor ::
               Ptr RawTStyle -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetTextFont" c_tstyle_gettextfont ::
               Ptr RawTStyle -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetTextSize" c_tstyle_gettextsize ::
               Ptr RawTStyle -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_ResetAttText" c_tstyle_resetatttext ::
               Ptr RawTStyle -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetTextAttributes"
               c_tstyle_settextattributes :: Ptr RawTStyle -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetTextAlign" c_tstyle_settextalign ::
               Ptr RawTStyle -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetTextAngle" c_tstyle_settextangle ::
               Ptr RawTStyle -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetTextColor" c_tstyle_settextcolor ::
               Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetTextFont" c_tstyle_settextfont ::
               Ptr RawTStyle -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetTextSize" c_tstyle_settextsize ::
               Ptr RawTStyle -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SetTextSizePixels"
               c_tstyle_settextsizepixels :: Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible "HROOTCoreTStyle.h TStyle_Clear"
               c_tstyle_clear :: Ptr RawTStyle -> CString -> IO ()

foreign import ccall interruptible "HROOTCoreTStyle.h TStyle_Draw"
               c_tstyle_draw :: Ptr RawTStyle -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_FindObject" c_tstyle_findobject ::
               Ptr RawTStyle -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_GetName" c_tstyle_getname ::
               Ptr RawTStyle -> IO CString

foreign import ccall interruptible "HROOTCoreTStyle.h TStyle_IsA"
               c_tstyle_isa :: Ptr RawTStyle -> IO (Ptr RawTClass)

foreign import ccall interruptible "HROOTCoreTStyle.h TStyle_Paint"
               c_tstyle_paint :: Ptr RawTStyle -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_printObj" c_tstyle_printobj ::
               Ptr RawTStyle -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_SaveAs" c_tstyle_saveas ::
               Ptr RawTStyle -> CString -> CString -> IO ()

foreign import ccall interruptible "HROOTCoreTStyle.h TStyle_Write"
               c_tstyle_write ::
               Ptr RawTStyle -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_Write_" c_tstyle_write_ ::
               Ptr RawTStyle -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_delete" c_tstyle_delete ::
               Ptr RawTStyle -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_tStyle_SetCanvasPreferGL"
               c_tstyle_tstyle_setcanvasprefergl ::
               Ptr RawTStyle -> CBool -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_tStyle_SetOptDate"
               c_tstyle_tstyle_setoptdate :: Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_tStyle_SetOptFile"
               c_tstyle_tstyle_setoptfile :: Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_tStyle_SetOptFit"
               c_tstyle_tstyle_setoptfit :: Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_tStyle_SetOptLogx"
               c_tstyle_tstyle_setoptlogx :: Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_tStyle_SetOptLogy"
               c_tstyle_tstyle_setoptlogy :: Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_tStyle_SetOptLogz"
               c_tstyle_tstyle_setoptlogz :: Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_tStyle_SetOptStat"
               c_tstyle_tstyle_setoptstat :: Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_tStyle_SetOptTitle"
               c_tstyle_tstyle_setopttitle :: Ptr RawTStyle -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTStyle.h TStyle_tStyle_SetPalette"
               c_tstyle_tstyle_setpalette :: Ptr RawTStyle -> CInt -> IO ()
