{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TSystem.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TSystem.RawType
import HROOT.Core.TSystem.FFI
import HROOT.Core.TSystem.Interface
import HROOT.Core.TSystem.Cast
import HROOT.Core.TSystem.RawType
import HROOT.Core.TSystem.Cast
import HROOT.Core.TSystem.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITSystem (TSystem) where
        processEvents = xform0 c_tsystem_processevents

instance () => ITNamed (TSystem) where
        setName = xform1 c_tsystem_setname
        setNameTitle = xform2 c_tsystem_setnametitle
        setTitle = xform1 c_tsystem_settitle

instance () => ITObject (TSystem) where
        clear = xform1 c_tsystem_clear
        draw = xform1 c_tsystem_draw
        findObject = xform1 c_tsystem_findobject
        getName = xform0 c_tsystem_getname
        isA = xform0 c_tsystem_isa
        paint = xform1 c_tsystem_paint
        printObj = xform1 c_tsystem_printobj
        saveAs = xform2 c_tsystem_saveas
        write = xform3 c_tsystem_write
        write_ = xform0 c_tsystem_write_

instance () => IDeletable (TSystem) where
        delete = xform0 c_tsystem_delete
