{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TVirtualPad.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TVirtualPad.RawType
import HROOT.Core.TVirtualPad.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_Clear" c_tvirtualpad_clear ::
               Ptr RawTVirtualPad -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_Draw" c_tvirtualpad_draw ::
               Ptr RawTVirtualPad -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_FindObject"
               c_tvirtualpad_findobject ::
               Ptr RawTVirtualPad -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_GetName" c_tvirtualpad_getname
               :: Ptr RawTVirtualPad -> IO CString

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_IsA" c_tvirtualpad_isa ::
               Ptr RawTVirtualPad -> IO (Ptr RawTClass)

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_Paint" c_tvirtualpad_paint ::
               Ptr RawTVirtualPad -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_printObj"
               c_tvirtualpad_printobj :: Ptr RawTVirtualPad -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SaveAs" c_tvirtualpad_saveas ::
               Ptr RawTVirtualPad -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_Write" c_tvirtualpad_write ::
               Ptr RawTVirtualPad -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_Write_" c_tvirtualpad_write_ ::
               Ptr RawTVirtualPad -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_GetLineColor"
               c_tvirtualpad_getlinecolor :: Ptr RawTVirtualPad -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_GetLineStyle"
               c_tvirtualpad_getlinestyle :: Ptr RawTVirtualPad -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_GetLineWidth"
               c_tvirtualpad_getlinewidth :: Ptr RawTVirtualPad -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_ResetAttLine"
               c_tvirtualpad_resetattline ::
               Ptr RawTVirtualPad -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetLineAttributes"
               c_tvirtualpad_setlineattributes :: Ptr RawTVirtualPad -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetLineColor"
               c_tvirtualpad_setlinecolor :: Ptr RawTVirtualPad -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetLineStyle"
               c_tvirtualpad_setlinestyle :: Ptr RawTVirtualPad -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetLineWidth"
               c_tvirtualpad_setlinewidth :: Ptr RawTVirtualPad -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetFillColor"
               c_tvirtualpad_setfillcolor :: Ptr RawTVirtualPad -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetFillStyle"
               c_tvirtualpad_setfillstyle :: Ptr RawTVirtualPad -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_ResetAttPad"
               c_tvirtualpad_resetattpad :: Ptr RawTVirtualPad -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetBottomMargin"
               c_tvirtualpad_setbottommargin ::
               Ptr RawTVirtualPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetLeftMargin"
               c_tvirtualpad_setleftmargin ::
               Ptr RawTVirtualPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetRightMargin"
               c_tvirtualpad_setrightmargin ::
               Ptr RawTVirtualPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetTopMargin"
               c_tvirtualpad_settopmargin :: Ptr RawTVirtualPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetMargin"
               c_tvirtualpad_setmargin ::
               Ptr RawTVirtualPad -> CFloat -> CFloat -> CFloat -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetAfile"
               c_tvirtualpad_setafile :: Ptr RawTVirtualPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetXfile"
               c_tvirtualpad_setxfile :: Ptr RawTVirtualPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetYfile"
               c_tvirtualpad_setyfile :: Ptr RawTVirtualPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetAstat"
               c_tvirtualpad_setastat :: Ptr RawTVirtualPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetXstat"
               c_tvirtualpad_setxstat :: Ptr RawTVirtualPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetYstat"
               c_tvirtualpad_setystat :: Ptr RawTVirtualPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_delete" c_tvirtualpad_delete ::
               Ptr RawTVirtualPad -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_cd" c_tvirtualpad_cd ::
               Ptr RawTVirtualPad -> CInt -> IO (Ptr RawTVirtualPad)

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_divide_tvirtualpad"
               c_tvirtualpad_divide_tvirtualpad ::
               Ptr RawTVirtualPad ->
                 CInt -> CInt -> CFloat -> CFloat -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_Modified"
               c_tvirtualpad_modified :: Ptr RawTVirtualPad -> CBool -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_Range" c_tvirtualpad_range ::
               Ptr RawTVirtualPad ->
                 CDouble -> CDouble -> CDouble -> CDouble -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetLogx" c_tvirtualpad_setlogx
               :: Ptr RawTVirtualPad -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetLogy" c_tvirtualpad_setlogy
               :: Ptr RawTVirtualPad -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_SetLogz" c_tvirtualpad_setlogz
               :: Ptr RawTVirtualPad -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTVirtualPad.h TVirtualPad_Update" c_tvirtualpad_update ::
               Ptr RawTVirtualPad -> IO ()
